-- Filename: CameraZoom.lua
-- Author: SMI Modding Team (Nicola)
-- Date: 06/11/2024
-- version: 1.0.0.0

CameraZoom = {}

CameraZoom.ORIGINAL_FOV = -1
CameraZoom.fov_multiplier = 1
CameraZoom.SENSITIVITY = 3
CameraZoom.y_offset = 0
CameraZoom.Y_STEP_SIZE = 0.2

function CameraZoom:update(dt)
    local player = g_currentMission.playerSystem.playersByUserId[g_currentMission.playerUserId]

    if g_gui == nil then
        return 
    elseif g_gui.currentGuiName ~= "" then
        return end

    local camera = getCamera()
    if player.isControlled and player.camera.thirdPersonCamera ~= camera then
        if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_WHEEL_DOWN) and Input.isMouseButtonPressed(Input.MOUSE_BUTTON_RIGHT) then
            CameraZoom.fov_multiplier = math.min(2, CameraZoom.fov_multiplier + CameraZoom.SENSITIVITY * dt / 1000)
            setFovY(camera, -CameraZoom.ORIGINAL_FOV * CameraZoom.fov_multiplier);

        elseif Input.isMouseButtonPressed(Input.MOUSE_BUTTON_WHEEL_DOWN) then
            local current_mission_player = g_currentMission.playerSystem.playersByUserId[g_currentMission.playerUserId]
            local cam_root_node = current_mission_player.camera.firstPersonCamera
            local x,y,z = getTranslation(cam_root_node)
            print(g_gui.currentGuiName)

            if CameraZoom.y_offset < 10 then
                setTranslation(cam_root_node, x, y + CameraZoom.Y_STEP_SIZE, z)
                CameraZoom.y_offset = CameraZoom.y_offset + CameraZoom.Y_STEP_SIZE 
            end

        elseif Input.isMouseButtonPressed(Input.MOUSE_BUTTON_WHEEL_UP) and Input.isMouseButtonPressed(Input.MOUSE_BUTTON_RIGHT) then
            CameraZoom.fov_multiplier = math.max(0.067, CameraZoom.fov_multiplier - CameraZoom.SENSITIVITY * dt / 1000);
            setFovY(camera, -CameraZoom.ORIGINAL_FOV * CameraZoom.fov_multiplier);

        elseif Input.isMouseButtonPressed(Input.MOUSE_BUTTON_WHEEL_UP) then
            local current_mission_player = g_currentMission.playerSystem.playersByUserId[g_currentMission.playerUserId]
            local cam_root_node = current_mission_player.camera.firstPersonCamera

            local x,y,z = getTranslation(cam_root_node)
            if CameraZoom.y_offset > -0.5 then
                setTranslation(cam_root_node, x, y - CameraZoom.Y_STEP_SIZE , z)
                CameraZoom.y_offset = CameraZoom.y_offset - CameraZoom.Y_STEP_SIZE 
            end

        elseif Input.isMouseButtonPressed(Input.MOUSE_BUTTON_MIDDLE) then
            setFovY(camera, -CameraZoom.ORIGINAL_FOV)
            local current_mission_player = g_currentMission.playerSystem.playersByUserId[g_currentMission.playerUserId]
            local cam_root_node = current_mission_player.camera.firstPersonCamera
            local x,y,z = getTranslation(cam_root_node)
            setTranslation(cam_root_node, x, y-CameraZoom.y_offset, z)
            CameraZoom.y_offset = 0
            CameraZoom.fov_multiplier = 1
        end
    end
end

addModEventListener(CameraZoom)